rules:
  - id: tainted-html-string
    languages:
      - java
    severity: ERROR
    message: Detected user input flowing into a manually constructed HTML string.
      You may be accidentally bypassing secure methods of rendering HTML by
      manually constructing HTML and this could create a cross-site scripting
      vulnerability, which could let attackers steal sensitive user data. To be
      sure this is safe, check that the HTML is rendered safely. You can use the
      OWASP ESAPI encoder if you must render user data.
    metadata:
      cwe:
        - "CWE-79: Improper Neutralization of Input During Web Page Generation
          ('Cross-site Scripting')"
      owasp:
        - A07:2017 - Cross-Site Scripting (XSS)
        - A03:2021 - Injection
      references:
        - https://cheatsheetseries.owasp.org/cheatsheets/Cross_Site_Scripting_Prevention_Cheat_Sheet.html
      category: security
      technology:
        - java
        - spring
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Cross-Site-Scripting (XSS)
    mode: taint
    pattern-sources:
      - label: INPUT
        patterns:
          - pattern-either:
              - pattern-inside: |
                  $METHODNAME(..., @$REQ(...) $TYPE $SOURCE,...) {
                    ...
                  }
              - pattern-inside: |
                  $METHODNAME(..., @$REQ $TYPE $SOURCE,...) {
                    ...
                  }
          - metavariable-regex:
              metavariable: $TYPE
              regex: ^(?!(Integer|Long|Float|Double|Char|Boolean|int|long|float|double|char|boolean))
          - metavariable-regex:
              metavariable: $REQ
              regex: (RequestBody|PathVariable|RequestParam|RequestHeader|CookieValue|ModelAttribute)
          - focus-metavariable: $SOURCE
      - label: CONCAT
        by-side-effect: true
        requires: INPUT
        patterns:
          - pattern-either:
              - pattern: |
                  "$HTMLSTR" + ...
              - pattern: |
                  "$HTMLSTR".concat(...)
              - patterns:
                  - pattern-inside: |
                      StringBuilder $SB = new StringBuilder("$HTMLSTR");
                      ...
                  - pattern: $SB.append(...)
              - patterns:
                  - pattern-inside: |
                      $VAR = "$HTMLSTR";
                      ...
                  - pattern: $VAR += ...
              - pattern: String.format("$HTMLSTR", ...)
              - patterns:
                  - pattern-inside: |
                      String $VAR = "$HTMLSTR";
                      ...
                  - pattern: String.format($VAR, ...)
          - metavariable-regex:
              metavariable: $HTMLSTR
              regex: ^<\w+
    pattern-propagators:
      - pattern: (StringBuilder $SB).append($...TAINTED)
        from: $...TAINTED
        to: $SB
      - pattern: $VAR += $...TAINTED
        from: $...TAINTED
        to: $VAR
    pattern-sinks:
      - requires: CONCAT
        patterns:
          - pattern-either:
              - pattern: new ResponseEntity<>($PAYLOAD, ...)
              - pattern: new ResponseEntity<$ERROR>($PAYLOAD, ...)
              - pattern: ResponseEntity. ... .body($PAYLOAD)
              - patterns:
                  - pattern: |
                      ResponseEntity.$RESPFUNC($PAYLOAD). ...
                  - metavariable-regex:
                      metavariable: $RESPFUNC
                      regex: ^(ok|of)$
          - focus-metavariable: $PAYLOAD
    pattern-sanitizers:
      - pattern-either:
          - pattern: Encode.forHtml(...)
          - pattern: (PolicyFactory $POLICY).sanitize(...)
          - pattern: (AntiSamy $AS).scan(...)
          - pattern: JSoup.clean(...)
  - id: md5-used-as-password
    languages:
      - java
    severity: WARNING
    message: It looks like MD5 is used as a password hash. MD5 is not considered a
      secure password hash because it can be cracked by an attacker in a short
      amount of time. Use a suitable password hashing function such as PBKDF2 or
      bcrypt. You can use `javax.crypto.SecretKeyFactory` with
      `SecretKeyFactory.getInstance("PBKDF2WithHmacSHA1")` or, if using Spring,
      `org.springframework.security.crypto.bcrypt`.
    metadata:
      category: security
      technology:
        - java
        - md5
      references:
        - https://tools.ietf.org/id/draft-lvelvindron-tls-md5-sha1-deprecate-01.html
        - https://github.com/returntocorp/semgrep-rules/issues/1609
        - https://docs.oracle.com/javase/7/docs/technotes/guides/security/StandardNames.html#SecretKeyFactory
        - https://docs.spring.io/spring-security/site/docs/current/api/org/springframework/security/crypto/bcrypt/BCryptPasswordEncoder.html
      owasp:
        - A03:2017 - Sensitive Data Exposure
        - A02:2021 - Cryptographic Failures
      cwe:
        - "CWE-327: Use of a Broken or Risky Cryptographic Algorithm"
      subcategory:
        - vuln
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Cryptographic Issues
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-inside: |
              $TYPE $MD = MessageDigest.getInstance("MD5");
              ...
          - pattern: $MD.digest(...);
    pattern-sinks:
      - patterns:
          - pattern: $MODEL.$METHOD(...);
          - metavariable-regex:
              metavariable: $METHOD
              regex: (?i)(.*password.*)
  - id: spel-injection
    message: A Spring expression is built with a dynamic value. The source of the
      value(s) should be verified to avoid that unfiltered values fall into this
      risky code evaluation.
    metadata:
      cwe:
        - "CWE-94: Improper Control of Generation of Code ('Code Injection')"
      owasp:
        - A03:2021 - Injection
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#SPEL_INJECTION
      category: security
      technology:
        - spring
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Code Injection
    severity: WARNING
    languages:
      - java
    patterns:
      - pattern-either:
          - pattern-inside: |
              class $CLASS {
                ...
                ExpressionParser $PARSER;
                ...
              }
          - pattern-inside: |
              class $CLASS {
                ...
                ExpressionParser $PARSER = ...;
                ...
              }
          - pattern-inside: |
              $X $METHOD(...) {
                ...
                ExpressionParser $PARSER = ...;
                ...
              }
          - pattern-inside: |
              class $CLASS {
                ...
                SpelExpressionParser $PARSER;
                ...
              }
          - pattern-inside: |
              class $CLASS {
                ...
                SpelExpressionParser $PARSER = ...;
                ...
              }
          - pattern-inside: |
              $X $METHOD(...) {
                ...
                SpelExpressionParser $PARSER = ...;
                ...
              }
          - pattern-inside: |
              class $CLASS {
                ...
                TemplateAwareExpressionParser $PARSER;
                ...
              }
          - pattern-inside: |
              class $CLASS {
                ...
                TemplateAwareExpressionParser $PARSER = ...;
                ...
              }
          - pattern-inside: |
              $X $METHOD(...) {
                ...
                TemplateAwareExpressionParser $PARSER = ...;
                ...
              }
      - pattern: |
          $X $METHOD(...) {
            ...
            $PARSER.parseExpression(...);
            ...
          }
      - pattern-not: |
          $X $METHOD(...) {
            ...
            $PARSER.parseExpression("...");
            ...
          }
      - pattern-not: |
          $X $METHOD(...) {
            ...
            String $S = "...";
            ...
            $PARSER.parseExpression($S);
            ...
          }
  - id: spring-csrf-disabled
    message: CSRF protection is disabled for this configuration. This is a security
      risk.
    metadata:
      cwe:
        - "CWE-352: Cross-Site Request Forgery (CSRF)"
      owasp:
        - A01:2021 - Broken Access Control
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#SPRING_CSRF_PROTECTION_DISABLED
      asvs:
        section: V4 Access Control
        control_id: 4.2.2 CSRF
        control_url: https://github.com/OWASP/ASVS/blob/master/4.0/en/0x12-V4-Access-Control.md#v42-operation-level-access-control
        version: "4"
      category: security
      technology:
        - spring
      references:
        - https://owasp.org/Top10/A01_2021-Broken_Access_Control
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: MEDIUM
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Cross-Site Request Forgery (CSRF)
    severity: WARNING
    languages:
      - java
    pattern: $OBJ.csrf(...).disable(...)
  - id: spring-sqli
    mode: taint
    pattern-sources:
      - patterns:
          - pattern: $ARG
          - pattern-inside: |
              public $T $M (..., String $ARG,...){...}
    pattern-sanitizers:
      - not_conflicting: true
        pattern-either:
          - patterns:
              - focus-metavariable: $A
              - pattern-inside: |
                  new $TYPE(...,$A,...);
    pattern-sinks:
      - patterns:
          - pattern-either:
              - patterns:
                  - focus-metavariable: $A
                  - pattern: |
                      new PreparedStatementCreatorFactory($A,...);
              - patterns:
                  - focus-metavariable: $A
                  - pattern: |
                      (JdbcTemplate $T).$M($A,...)
              - patterns:
                  - pattern: (String $A)
                  - pattern-inside: |
                      (JdbcTemplate $T).batchUpdate(...)
              - patterns:
                  - focus-metavariable: $A
                  - pattern: |
                      NamedParameterBatchUpdateUtils.$M($A,...)
              - patterns:
                  - focus-metavariable: $A
                  - pattern: |
                      BatchUpdateUtils.$M($A,...)
    message: Detected a string argument from a public method contract in a raw SQL
      statement. This could lead to SQL injection if variables in the SQL
      statement are not properly sanitized. Use a prepared statements
      (java.sql.PreparedStatement) instead. You can obtain a PreparedStatement
      using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    options:
      taint_assume_safe_numbers: true
      taint_assume_safe_booleans: true
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - spring
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: spring-unvalidated-redirect
    message: Application redirects a user to a destination URL specified by a user
      supplied parameter that is not validated.
    metadata:
      cwe:
        - "CWE-601: URL Redirection to Untrusted Site ('Open Redirect')"
      owasp:
        - A01:2021 - Broken Access Control
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#UNVALIDATED_REDIRECT
      category: security
      technology:
        - spring
      references:
        - https://owasp.org/Top10/A01_2021-Broken_Access_Control
      subcategory:
        - vuln
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Open Redirect
    severity: WARNING
    languages:
      - java
    pattern-either:
      - pattern: |
          $X $METHOD(...,String $URL,...) {
            return "redirect:" + $URL;
          }
      - pattern: |
          $X $METHOD(...,String $URL,...) {
            ...
            String $REDIR = "redirect:" + $URL;
            ...
            return $REDIR;
            ...
          }
      - pattern: |
          $X $METHOD(...,String $URL,...) {
            ...
            new ModelAndView("redirect:" + $URL);
            ...
          }
      - pattern: |-
          $X $METHOD(...,String $URL,...) {
            ...
            String $REDIR = "redirect:" + $URL;
            ...
            new ModelAndView($REDIR);
            ...
          }
  - id: tainted-file-path
    languages:
      - java
    severity: ERROR
    message: Detected user input controlling a file path. An attacker could control
      the location of this file, to include going backwards in the directory
      with '../'. To address this, ensure that user-controlled variables in file
      paths are sanitized. You may also consider using a utility method such as
      org.apache.commons.io.FilenameUtils.getName(...) to only retrieve the file
      name from the path.
    options:
      interfile: true
    metadata:
      cwe:
        - "CWE-23: Relative Path Traversal"
      owasp:
        - A01:2021 - Broken Access Control
      references:
        - https://owasp.org/www-community/attacks/Path_Traversal
      category: security
      technology:
        - java
        - spring
      subcategory:
        - vuln
      impact: HIGH
      likelihood: MEDIUM
      confidence: HIGH
      interfile: true
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Path Traversal
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern-inside: |
                  $METHODNAME(..., @$REQ(...) $TYPE $SOURCE,...) {
                    ...
                  }
              - pattern-inside: |
                  $METHODNAME(..., @$REQ $TYPE $SOURCE,...) {
                    ...
                  }
          - metavariable-regex:
              metavariable: $TYPE
              regex: ^(?!(Integer|Long|Float|Double|Char|Boolean|int|long|float|double|char|boolean))
          - metavariable-regex:
              metavariable: $REQ
              regex: (RequestBody|PathVariable|RequestParam|RequestHeader|CookieValue|ModelAttribute)
          - focus-metavariable: $SOURCE
    pattern-sinks:
      - patterns:
          - pattern-either:
              - pattern: new File(...)
              - pattern: new java.io.File(...)
              - pattern: new FileReader(...)
              - pattern: new java.io.FileReader(...)
              - pattern: new FileInputStream(...)
              - pattern: new java.io.FileInputStream(...)
              - pattern: (Paths $PATHS).get(...)
              - patterns:
                  - pattern: |
                      $CLASS.$FUNC(...)
                  - metavariable-regex:
                      metavariable: $FUNC
                      regex: ^(getResourceAsStream|getResource)$
              - patterns:
                  - pattern-either:
                      - pattern: new ClassPathResource($FILE, ...)
                      - pattern: ResourceUtils.getFile($FILE, ...)
                      - pattern: new FileOutputStream($FILE, ...)
                      - pattern: new java.io.FileOutputStream($FILE, ...)
                      - pattern: new StreamSource($FILE, ...)
                      - pattern: new javax.xml.transform.StreamSource($FILE, ...)
                      - pattern: FileUtils.openOutputStream($FILE, ...)
                  - focus-metavariable: $FILE
    pattern-sanitizers:
      - pattern: org.apache.commons.io.FilenameUtils.getName(...)
  - id: tainted-sql-string
    languages:
      - java
    severity: ERROR
    message: User data flows into this manually-constructed SQL string. User data
      can be safely inserted into SQL strings using prepared statements or an
      object-relational mapper (ORM). Manually-constructed SQL strings is a
      possible indicator of SQL injection, which could let an attacker steal or
      manipulate data from the database. Instead, use prepared statements
      (`connection.PreparedStatement`) or a safe library.
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://docs.oracle.com/javase/7/docs/api/java/sql/PreparedStatement.html
      category: security
      technology:
        - spring
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      interfile: true
      vulnerability_class:
        - SQL Injection
    options:
      taint_assume_safe_numbers: true
      taint_assume_safe_booleans: true
      interfile: true
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern-inside: |
                  $METHODNAME(..., @$REQ(...) $TYPE $SOURCE,...) {
                    ...
                  }
              - pattern-inside: |
                  $METHODNAME(..., @$REQ $TYPE $SOURCE,...) {
                    ...
                  }
          - metavariable-regex:
              metavariable: $REQ
              regex: (RequestBody|PathVariable|RequestParam|RequestHeader|CookieValue)
          - metavariable-regex:
              metavariable: $TYPE
              regex: ^(?!(Integer|Long|Float|Double|Char|Boolean|int|long|float|double|char|boolean))
          - focus-metavariable: $SOURCE
    pattern-sinks:
      - patterns:
          - pattern-either:
              - pattern: |
                  "$SQLSTR" + ...
              - pattern: |
                  "$SQLSTR".concat(...)
              - patterns:
                  - pattern-inside: |
                      StringBuilder $SB = new StringBuilder("$SQLSTR");
                      ...
                  - pattern: $SB.append(...)
              - patterns:
                  - pattern-inside: |
                      $VAR = "$SQLSTR";
                      ...
                  - pattern: $VAR += ...
              - pattern: String.format("$SQLSTR", ...)
              - patterns:
                  - pattern-inside: |
                      String $VAR = "$SQLSTR";
                      ...
                  - pattern: String.format($VAR, ...)
          - pattern-not-inside: System.out.println(...)
          - pattern-not-inside: $LOG.info(...)
          - pattern-not-inside: $LOG.warn(...)
          - pattern-not-inside: $LOG.warning(...)
          - pattern-not-inside: $LOG.debug(...)
          - pattern-not-inside: $LOG.debugging(...)
          - pattern-not-inside: $LOG.error(...)
          - pattern-not-inside: new Exception(...)
          - pattern-not-inside: throw ...;
          - metavariable-regex:
              metavariable: $SQLSTR
              regex: (?i)(select|delete|insert|create|update|alter|drop)\b
  - id: tainted-system-command
    languages:
      - java
    severity: ERROR
    mode: taint
    pattern-propagators:
      - pattern: (StringBuilder $STRB).append($INPUT)
        from: $INPUT
        to: $STRB
        label: CONCAT
        requires: INPUT
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern-inside: |
                  $METHODNAME(..., @$REQ(...) $TYPE $SOURCE,...) {
                    ...
                  }
              - pattern-inside: |
                  $METHODNAME(..., @$REQ $TYPE $SOURCE,...) {
                    ...
                  }
          - metavariable-regex:
              metavariable: $TYPE
              regex: ^(?!(Integer|Long|Float|Double|Char|Boolean|int|long|float|double|char|boolean))
          - metavariable-regex:
              metavariable: $REQ
              regex: (RequestBody|PathVariable|RequestParam|RequestHeader|CookieValue|ModelAttribute)
          - focus-metavariable: $SOURCE
        label: INPUT
      - patterns:
          - pattern-either:
              - pattern: $X + $SOURCE
              - pattern: $SOURCE + $Y
              - pattern: String.format("...", ..., $SOURCE, ...)
              - pattern: String.join("...", ..., $SOURCE, ...)
              - pattern: (String $STR).concat($SOURCE)
              - pattern: $SOURCE.concat(...)
              - pattern: $X += $SOURCE
              - pattern: $SOURCE += $X
        label: CONCAT
        requires: INPUT
    pattern-sinks:
      - patterns:
          - pattern-either:
              - pattern: |
                  (Process $P) = new Process(...);
              - pattern: |
                  (ProcessBuilder $PB).command(...);
              - patterns:
                  - pattern-either:
                      - pattern: |
                          (Runtime $R).$EXEC(...);
                      - pattern: |
                          Runtime.getRuntime(...).$EXEC(...);
                  - metavariable-regex:
                      metavariable: $EXEC
                      regex: (exec|loadLibrary|load)
              - patterns:
                  - pattern: |
                      (ProcessBuilder $PB).command(...).$ADD(...);
                  - metavariable-regex:
                      metavariable: $ADD
                      regex: (add|addAll)
              - patterns:
                  - pattern-either:
                      - patterns:
                          - pattern-inside: |
                              $BUILDER = new ProcessBuilder(...);
                              ...
                          - pattern: $BUILDER.start(...)
                      - pattern: |
                          new ProcessBuilder(...). ... .start(...);
        requires: CONCAT
    message: "Detected user input entering a method which executes a system command.
      This could result in a command injection vulnerability, which allows an
      attacker to inject an arbitrary system command onto the server. The
      attacker could download malware onto or steal data from the server.
      Instead, use ProcessBuilder, separating the command into individual
      arguments, like this: `new ProcessBuilder(\"ls\", \"-al\",
      targetDirectory)`. Further, make sure you hardcode or allowlist the actual
      command so that attackers can't run arbitrary commands."
    metadata:
      cwe:
        - "CWE-78: Improper Neutralization of Special Elements used in an OS
          Command ('OS Command Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      category: security
      technology:
        - java
        - spring
      confidence: HIGH
      references:
        - https://www.stackhawk.com/blog/command-injection-java/
        - https://cheatsheetseries.owasp.org/cheatsheets/OS_Command_Injection_Defense_Cheat_Sheet.html
        - https://github.com/github/codeql/blob/main/java/ql/src/Security/CWE/CWE-078/ExecUnescaped.java
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: HIGH
      impact: HIGH
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Command Injection
  - id: tainted-url-host
    languages:
      - java
    severity: ERROR
    message: User data flows into the host portion of this manually-constructed URL.
      This could allow an attacker to send data to their own server, potentially
      exposing sensitive data such as cookies or authorization information sent
      with this request. They could also probe internal servers or other
      resources that the server runnig this code can access. (This is called
      server-side request forgery, or SSRF.) Do not allow arbitrary hosts.
      Instead, create an allowlist for approved hosts hardcode the correct host,
      or ensure that the user data can only affect the path or parameters.
    options:
      interfile: true
    metadata:
      cwe:
        - "CWE-918: Server-Side Request Forgery (SSRF)"
      owasp:
        - A10:2021 - Server-Side Request Forgery (SSRF)
      references:
        - https://cheatsheetseries.owasp.org/cheatsheets/Server_Side_Request_Forgery_Prevention_Cheat_Sheet.html
      category: security
      technology:
        - java
        - spring
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      impact: MEDIUM
      likelihood: MEDIUM
      confidence: MEDIUM
      interfile: true
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Server-Side Request Forgery (SSRF)
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern-inside: |
                  $METHODNAME(..., @$REQ(...) $TYPE $SOURCE,...) {
                    ...
                  }
              - pattern-inside: |
                  $METHODNAME(..., @$REQ $TYPE $SOURCE,...) {
                    ...
                  }
          - metavariable-regex:
              metavariable: $TYPE
              regex: ^(?!(Integer|Long|Float|Double|Char|Boolean|int|long|float|double|char|boolean))
          - metavariable-regex:
              metavariable: $REQ
              regex: (RequestBody|PathVariable|RequestParam|RequestHeader|CookieValue|ModelAttribute)
          - focus-metavariable: $SOURCE
    pattern-sinks:
      - pattern-either:
          - pattern: new URL($ONEARG)
          - patterns:
              - pattern-either:
                  - pattern: |
                      "$URLSTR" + ...
                  - pattern: |
                      "$URLSTR".concat(...)
                  - patterns:
                      - pattern-inside: |
                          StringBuilder $SB = new StringBuilder("$URLSTR");
                          ...
                      - pattern: $SB.append(...)
                  - patterns:
                      - pattern-inside: |
                          $VAR = "$URLSTR";
                          ...
                      - pattern: $VAR += ...
                  - patterns:
                      - pattern: String.format("$URLSTR", ...)
                      - pattern-not: String.format("$URLSTR", "...", ...)
                  - patterns:
                      - pattern-inside: |
                          String $VAR = "$URLSTR";
                          ...
                      - pattern: String.format($VAR, ...)
              - metavariable-regex:
                  metavariable: $URLSTR
                  regex: http(s?)://%(v|s|q).*
  - id: unrestricted-request-mapping
    patterns:
      - pattern-inside: |
          @RequestMapping(...)
          $RETURNTYPE $METHOD(...) { ... }
      - pattern-not-inside: |
          @RequestMapping(..., method = $X, ...)
          $RETURNTYPE $METHOD(...) { ... }
      - pattern: |
          RequestMapping
    message: Detected a method annotated with 'RequestMapping' that does not specify
      the HTTP method. CSRF protections are not enabled for GET, HEAD, TRACE, or
      OPTIONS, and by default all HTTP methods are allowed when the HTTP method
      is not explicitly specified. This means that a method that performs state
      changes could be vulnerable to CSRF attacks. To mitigate, add the 'method'
      field and specify the HTTP method (such as 'RequestMethod.POST').
    severity: WARNING
    metadata:
      cwe:
        - "CWE-352: Cross-Site Request Forgery (CSRF)"
      owasp:
        - A01:2021 - Broken Access Control
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#SPRING_CSRF_UNRESTRICTED_REQUEST_MAPPING
      references:
        - https://find-sec-bugs.github.io/bugs.htm#SPRING_CSRF_UNRESTRICTED_REQUEST_MAPPING
      category: security
      technology:
        - spring
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: MEDIUM
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Cross-Site Request Forgery (CSRF)
    languages:
      - java
  - id: bypass-tls-verification
    message: Checks for redefinitions of functions that check TLS/SSL certificate
      verification. This can lead to vulnerabilities, as simple errors in the
      code can result in lack of proper certificate validation. This should only
      be used for debugging purposes because it leads to vulnerability to MTM
      attacks.
    severity: WARNING
    metadata:
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      category: security
      cwe: "CWE-319: Cleartext Transmission of Sensitive Information"
      owasp: A03:2017 - Sensitive Data Exposure
      references:
        - https://stackoverflow.com/questions/4072585/disabling-ssl-certificate-validation-in-spring-resttemplate
        - https://stackoverflow.com/questions/35530558/how-to-fix-unsafe-implementation-of-x509trustmanager-in-android-app?rq=1
      subcategory:
        - vuln
      technology:
        - spring
      vulnerability: Insecure Transport
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Mishandled Sensitive Information
    languages:
      - java
    pattern-either:
      - pattern: |
          new HostnameVerifier() {
            ...
            public boolean verify(String hostname, SSLSession session) {
              ...
            }
            ...
          };
      - pattern: >
          public RestTemplate restTemplate() throws KeyStoreException,
          NoSuchAlgorithmException, KeyManagementException {
            ...
            TrustStrategy $FUNCNAME = (X509Certificate[] chain, String authType) -> ...;
            ...
          }
      - pattern: >
          TrustStrategy $FUNCNAME= new TrustStrategy() {
            ...
            public boolean isTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {
              ...
            }
            ...
          };
  - id: spring-ftp-request
    message: Checks for outgoing connections to ftp servers via Spring plugin
      ftpSessionFactory. FTP does not encrypt traffic, possibly leading to PII
      being sent plaintext over the network.
    severity: WARNING
    metadata:
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      category: security
      cwe: "CWE-319: Cleartext Transmission of Sensitive Information"
      owasp: A03:2017 - Sensitive Data Exposure
      references:
        - https://docs.spring.io/spring-integration/api/org/springframework/integration/ftp/session/AbstractFtpSessionFactory.html#setClientMode-int-
      subcategory:
        - vuln
      technology:
        - spring
      vulnerability: Insecure Transport
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Mishandled Sensitive Information
    languages:
      - java
    fix-regex:
      regex: "[fF][tT][pP]://"
      replacement: sftp://
      count: 1
    pattern-either:
      - pattern: |
          $SF = new DefaultFtpSessionFactory(...);
          ...
          $SF.setHost("=~/^[fF][tT][pP]://.*/");
          ...
          $SF.$FUNC(...);
      - pattern: |
          $SF = new DefaultFtpSessionFactory(...);
          ...
          String $URL = "=~/^[fF][tT][pP]://.*/";
          ...
          $SF.setHost($URL);
          ...
          $SF.$FUNC(...);
  - id: spring-http-request
    message: Checks for requests sent via Java Spring RestTemplate API to http://
      URLS. This is dangerous because the server is attempting to connect to a
      website that does not encrypt traffic with TLS. Instead, send requests
      only to https:// URLS.
    severity: WARNING
    metadata:
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      category: security
      cwe: "CWE-319: Cleartext Transmission of Sensitive Information"
      owasp: A03:2017 - Sensitive Data Exposure
      references:
        - https://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/web/client/RestTemplate.html#delete-java.lang.String-java.util.Map-
        - https://www.baeldung.com/rest-template
      subcategory:
        - vuln
      technology:
        - spring
      vulnerability: Insecure Transport
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Mishandled Sensitive Information
    languages:
      - java
    fix-regex:
      regex: "[Hh][Tt][Tt][Pp]://"
      replacement: https://
      count: 1
    patterns:
      - pattern-either:
          - pattern: |
              $RESTTEMP = new RestTemplate(...);
              ...
              $RESTTEMP.$FUNC("=~/[hH][tT][tT][pP]://.*/", ...);
          - pattern: |
              $RESTTEMP = new RestTemplate(...);
              ...
              String $URL = "=~/[hH][tT][tT][pP]://.*/";
              ...
              $RESTTEMP.$FUNC($URL, ...);
          - pattern: |
              $RESTTEMP = new RestTemplate(...);
              ...
              $URL = new URI(..., "=~/[hH][tT][tT][pP]://.*/", ...);
              ...
              $RESTTEMP.$FUNC($URL, ...);
      - metavariable-regex:
          metavariable: $FUNC
          regex: (delete|doExecute|exchange|getForEntity|getForObject|headForHeaders|optionsForAllow|patchForObject|postForEntity|postForLocation|postForObject|put)
  - id: find-sql-string-concatenation
    message: In $METHOD, $X is used to construct a SQL query via string concatenation.
    languages:
      - java
    severity: ERROR
    pattern-either:
      - pattern: >
          $RETURN $METHOD(...,String $X,...){
            ...
            Session $SESSION = ...;
            ...
            String $QUERY = ... + $X + ...;
            ...
            PreparedStatement $PS = $SESSION.connection().prepareStatement($QUERY);
            ...
            ResultSet $RESULT = $PS.executeQuery();
            ...
          }
      - pattern: >
          $RETURN $METHOD(...,String $X,...){
            ...
            String $QUERY = ... + $X + ...;
            ...
            Session $SESSION = ...;
            ...
            PreparedStatement $PS = $SESSION.connection().prepareStatement($QUERY);
            ...
            ResultSet $RESULT = $PS.executeQuery();
            ...
          }
    metadata:
      category: security
      technology:
        - jboss
      confidence: MEDIUM
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: LOW
      impact: HIGH
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: command-injection-formatted-runtime-call
    patterns:
      - metavariable-pattern:
          metavariable: $RUNTIME
          patterns:
            - pattern-either:
                - pattern: (java.lang.Runtime $R)
                - pattern: java.lang.Runtime.getRuntime(...)
      - pattern-either:
          - pattern: $RUNTIME.exec($X + $Y);
          - pattern: $RUNTIME.exec(String.format(...));
          - pattern: $RUNTIME.loadLibrary($X + $Y);
          - pattern: $RUNTIME.loadLibrary(String.format(...));
          - patterns:
              - pattern-either:
                  - pattern: >
                      $RUNTIME.exec("=~/(sh|bash|ksh|csh|tcsh|zsh)/", "-c",
                      $ARG,...)
                  - pattern: >
                      $RUNTIME.exec(Arrays.asList("=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...),...)
                  - pattern: >
                      $RUNTIME.exec(new
                      String[]{"=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...},...)
                  - patterns:
                      - pattern-either:
                          - pattern: |
                              $RUNTIME.exec($CMD,"-c",$ARG,...)
                          - pattern: >
                              $RUNTIME.exec(Arrays.asList($CMD,"-c",$ARG,...),...)
                          - pattern: >
                              $RUNTIME.exec(new String[]{$CMD,"-c",$ARG,...},...)
                      - pattern-inside: |
                          $CMD = "=~/(sh|bash|ksh|csh|tcsh|zsh)/";
                          ...
                  - patterns:
                      - pattern-either:
                          - pattern: |
                              $RUNTIME.exec($CMD, $EXECUTE, $ARG, ...)
                      - pattern-inside: >
                          $CMD = new String[]{"=~/(sh|bash|ksh|csh|tcsh|zsh)/",
                          ...};

                          ...
                  - patterns:
                      - pattern-either:
                          - pattern: >
                              $RUNTIME.exec("=~/(sh|bash|ksh|csh|tcsh|zsh)/",
                              $BASH, $ARG,...)
                          - pattern: >
                              $RUNTIME.exec(Arrays.asList("=~/(sh|bash|ksh|csh|tcsh|zsh)/",$BASH,$ARG,...),...)
                          - pattern: >
                              $RUNTIME.exec(new
                              String[]{"=~/(sh|bash|ksh|csh|tcsh|zsh)/",$BASH,$ARG,...},...)
                      - pattern-inside: |
                          $BASH = new String[]{"=~/(-c)/", ...};
                          ...
              - pattern-not-inside: |
                  $ARG = "...";
                  ...
              - pattern-not: |
                  $RUNTIME.exec("...","...","...",...)
              - pattern-not: |
                  $RUNTIME.exec(new String[]{"...","...","...",...},...)
              - pattern-not: |
                  $RUNTIME.exec(Arrays.asList("...","...","...",...),...)
    message: A formatted or concatenated string was detected as input to a
      java.lang.Runtime call. This is dangerous if a variable is controlled by
      user input and could result in a command injection. Ensure your variables
      are not controlled by users or sufficiently sanitized.
    metadata:
      cwe:
        - "CWE-78: Improper Neutralization of Special Elements used in an OS
          Command ('OS Command Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#COMMAND_INJECTION.
      category: security
      technology:
        - java
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Command Injection
    severity: ERROR
    languages:
      - java
  - id: command-injection-process-builder
    pattern-either:
      - patterns:
          - pattern: |
              new ProcessBuilder($CMD,...)
          - pattern-not-inside: |
              $CMD = "...";
              ...
          - pattern-not-inside: |
              $CMD = Arrays.asList("...",...);
              ...
          - pattern-not-inside: |
              $CMD = new String[]{"...",...};
              ...
          - pattern-not: |
              new ProcessBuilder("...",...)
          - pattern-not: |
              new ProcessBuilder(new String[]{"...",...},...)
          - pattern-not: |
              new ProcessBuilder(Arrays.asList("...",...),...)
      - patterns:
          - pattern: |
              $PB.command($CMD,...)
          - pattern-inside: |
              $TYPE $PB = new ProcessBuilder(...);
              ...
          - pattern-not-inside: |
              $CMD = "...";
              ...
          - pattern-not-inside: |
              $CMD = Arrays.asList("...",...);
              ...
          - pattern-not-inside: |
              $CMD = new String[]{"...",...};
              ...
          - pattern-not: |
              $PB.command("...",...)
          - pattern-not: |
              $PB.command(new String[]{"...",...},...)
          - pattern-not: |
              $PB.command(Arrays.asList("...",...),...)
      - patterns:
          - pattern-either:
              - pattern: >
                  new
                  ProcessBuilder("=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...)
              - pattern: |
                  new ProcessBuilder("cmd","/c",$ARG,...)
              - pattern: |
                  new ProcessBuilder(Arrays.asList("cmd","/c",$ARG,...),...)
              - pattern: |
                  new ProcessBuilder(new String[]{"cmd","/c",$ARG,...},...)
              - patterns:
                  - pattern-either:
                      - pattern: |
                          new ProcessBuilder($CMD,"/c",$ARG,...)
                      - pattern: >
                          new
                          ProcessBuilder(Arrays.asList($CMD,"/c",$ARG,...),...)
                      - pattern: >
                          new ProcessBuilder(new
                          String[]{$CMD,"/c",$ARG,...},...)
                  - pattern-inside: |
                      $CMD = "cmd";
                      ...
          - pattern-not-inside: |
              $ARG = "...";
              ...
          - pattern-not: |
              new ProcessBuilder("...","...","...",...)
          - pattern-not: |
              new ProcessBuilder(new String[]{"...","...","...",...},...)
          - pattern-not: |
              new ProcessBuilder(Arrays.asList("...","...","...",...),...)
      - patterns:
          - pattern-either:
              - pattern: |
                  $PB.command("=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...)
              - pattern: |
                  $PB.command("cmd","/c",$ARG,...)
              - pattern: >
                  $PB.command(Arrays.asList("=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...),...)
              - pattern: |
                  $PB.command(Arrays.asList("cmd","/c",$ARG,...),...)
              - pattern: >
                  $PB.command(new
                  String[]{"=~/(sh|bash|ksh|csh|tcsh|zsh)/","-c",$ARG,...},...)
              - pattern: |
                  $PB.command(new String[]{"cmd","/c",$ARG,...},...)
              - patterns:
                  - pattern-either:
                      - pattern: |
                          $PB.command($CMD,"-c",$ARG,...)
                      - pattern: |
                          $PB.command(Arrays.asList($CMD,"-c",$ARG,...),...)
                      - pattern: |
                          $PB.command(new String[]{$CMD,"-c",$ARG,...},...)
                  - pattern-inside: |
                      $CMD = "=~/(sh|bash|ksh|csh|tcsh|zsh)/";
                      ...
              - patterns:
                  - pattern-either:
                      - pattern: |
                          $PB.command($CMD,"/c",$ARG,...)
                      - pattern: |
                          $PB.command(Arrays.asList($CMD,"/c",$ARG,...),...)
                      - pattern: |
                          $PB.command(new String[]{$CMD,"/c",$ARG,...},...)
                  - pattern-inside: |
                      $CMD = "cmd";
                      ...
          - pattern-inside: |
              $TYPE $PB = new ProcessBuilder(...);
              ...
          - pattern-not-inside: |
              $ARG = "...";
              ...
          - pattern-not: |
              $PB.command("...","...","...",...)
          - pattern-not: |
              $PB.command(new String[]{"...","...","...",...},...)
          - pattern-not: |
              $PB.command(Arrays.asList("...","...","...",...),...)
    message: A formatted or concatenated string was detected as input to a
      ProcessBuilder call. This is dangerous if a variable is controlled by user
      input and could result in a command injection. Ensure your variables are
      not controlled by users or sufficiently sanitized.
    metadata:
      cwe:
        - "CWE-78: Improper Neutralization of Special Elements used in an OS
          Command ('OS Command Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      category: security
      technology:
        - java
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Command Injection
    severity: ERROR
    languages:
      - java
  - id: formatted-sql-string
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#SQL_INJECTION
      asvs:
        section: "V5: Validation, Sanitization and Encoding Verification Requirements"
        control_id: 5.3.5 Injection
        control_url: https://github.com/OWASP/ASVS/blob/master/4.0/en/0x13-V5-Validation-Sanitization-Encoding.md#v53-output-encoding-and-injection-prevention-requirements
        version: "4"
      references:
        - https://cheatsheetseries.owasp.org/cheatsheets/SQL_Injection_Prevention_Cheat_Sheet.html
        - https://docs.oracle.com/javase/tutorial/jdbc/basics/prepared.html#create_ps
        - https://software-security.sans.org/developer-how-to/fix-sql-injection-in-java-using-prepared-callable-statement
      category: security
      technology:
        - java
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
    options:
      taint_assume_safe_numbers: true
      taint_assume_safe_booleans: true
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern: |
                  (HttpServletRequest $REQ)
              - patterns:
                  - pattern-inside: |
                      $ANNOT $FUNC (..., $INPUT, ...) {
                        ...
                      }
                  - pattern: (String $INPUT)
          - focus-metavariable: $INPUT
        label: INPUT
      - patterns:
          - pattern-either:
              - pattern: $X + $INPUT
              - pattern: $X += $INPUT
              - pattern: $STRB.append($INPUT)
              - pattern: String.format(..., $INPUT, ...)
              - pattern: String.join(..., $INPUT, ...)
              - pattern: (String $STR).concat($INPUT)
              - pattern: $INPUT.concat(...)
              - pattern: new $STRB(..., $INPUT, ...)
        label: CONCAT
        requires: INPUT
    pattern-propagators:
      - pattern: (StringBuffer $S).append($X)
        from: $X
        to: $S
      - pattern: (StringBuilder $S).append($X)
        from: $X
        to: $S
    pattern-sinks:
      - patterns:
          - pattern-not: $S.$SQLFUNC(<... "=~/.*TABLE *$/" ...>)
          - pattern-not: $S.$SQLFUNC(<... "=~/.*TABLE %s$/" ...>)
          - pattern-either:
              - pattern: (Statement $S).$SQLFUNC(...)
              - pattern: (PreparedStatement $P).$SQLFUNC(...)
              - pattern: (Connection $C).createStatement(...).$SQLFUNC(...)
              - pattern: (Connection $C).prepareStatement(...).$SQLFUNC(...)
              - pattern: (EntityManager $EM).$SQLFUNC(...)
          - metavariable-regex:
              metavariable: $SQLFUNC
              regex: execute|executeQuery|createQuery|query|addBatch|nativeSQL|create|prepare
        requires: CONCAT
    pattern-sanitizers:
      - patterns:
          - pattern: (CriteriaBuilder $CB).$ANY(...)
    severity: ERROR
    languages:
      - java
  - id: hibernate-sqli
    pattern-either:
      - patterns:
          - pattern-either:
              - pattern-inside: |
                  String $SQL = $X + $Y;
                  ...
              - pattern-inside: |
                  String $SQL = String.format(...);
                  ...
              - pattern-inside: |
                  $VAL $FUNC(...,String $SQL,...) {
                  ...
                  }
          - pattern-not-inside: |
              String $SQL = "..." + "...";
              ...
          - pattern: org.hibernate.criterion.Restrictions.sqlRestriction($SQL,...)
      - pattern: org.hibernate.criterion.Restrictions.sqlRestriction(String.format(...),...)
      - patterns:
          - pattern: org.hibernate.criterion.Restrictions.sqlRestriction($X + $Y,...)
          - pattern-not: org.hibernate.criterion.Restrictions.sqlRestriction("..." +
              "...",...)
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          String $SQL = $X + $Y;
                          ...
                      - pattern-inside: |
                          String $SQL = String.format(...);
                          ...
                      - pattern-inside: |
                          $TYPE $FUNC(...,String $SQL,...) {
                            ...
                          }
                  - pattern-not-inside: |
                      String $SQL = "..." + "...";
                      ...
                  - pattern: $SESSION.$METHOD($SQL,...)
              - pattern: |
                  $SESSION.$METHOD(String.format(...),...);
              - pattern: |
                  $SESSION.$METHOD($X + $Y,...);
          - pattern-either:
              - pattern-inside: |
                  org.hibernate.Session $SESSION = ...;
                  ...
              - pattern-inside: |
                  $TYPE $FUNC(...,org.hibernate.Session $SESSION,...) {
                    ...
                  }
          - pattern-not: |
              $SESSION.$METHOD("..." + "...",...);
          - metavariable-regex:
              metavariable: $METHOD
              regex: ^(createQuery|createSQLQuery)$
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#SQL_INJECTION_HIBERNATE
      asvs:
        section: V5 Stored Cryptography Verification Requirements
        control_id: 5.3.5 Insecure Custom Algorithm
        control_url: https://github.com/OWASP/ASVS/blob/master/4.0/en/0x13-V5-Validation-Sanitization-Encoding.md#v53-output-encoding-and-injection-prevention-requirements
        version: "4"
      category: security
      technology:
        - hibernate
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
    languages:
      - java
    severity: WARNING
  - id: jdbc-sqli
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    patterns:
      - pattern-either:
          - patterns:
              - pattern-either:
                  - pattern-inside: |
                      String $SQL = $X + $Y;
                      ...
                  - pattern-inside: |
                      String $SQL = String.format(...);
                      ...
                  - pattern-inside: |
                      $VAL $FUNC(...,String $SQL,...) {
                        ...
                      }
              - pattern-not-inside: |
                  String $SQL = "..." + "...";
                  ...
              - pattern: $S.$METHOD($SQL,...)
          - pattern: |
              $S.$METHOD(String.format(...),...);
          - pattern: |
              $S.$METHOD($X + $Y,...);
      - pattern-either:
          - pattern-inside: |
              java.sql.Statement $S = ...;
              ...
          - pattern-inside: |
              $TYPE $FUNC(...,java.sql.Statement $S,...) {
                ...
              }
      - pattern-not: |
          $S.$METHOD("..." + "...",...);
      - metavariable-regex:
          metavariable: $METHOD
          regex: ^(executeQuery|execute|executeUpdate|executeLargeUpdate|addBatch|nativeSQL)$
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - jdbc
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: jdo-sqli
    pattern-either:
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          String $SQL = $X + $Y;
                          ...
                      - pattern-inside: |
                          String $SQL = String.format(...);
                          ...
                      - pattern-inside: |
                          $TYPE $FUNC(...,String $SQL,...) {
                            ...
                          }
                  - pattern-not-inside: |
                      String $SQL = "..." + "...";
                      ...
                  - pattern: $Q.$METHOD($SQL,...)
              - pattern: |
                  $Q.$METHOD(String.format(...),...);
              - pattern: |
                  $Q.$METHOD($X + $Y,...);
          - pattern-either:
              - pattern-inside: |
                  javax.jdo.Query $Q = ...;
                  ...
              - pattern-inside: |
                  $TYPE $FUNC(...,javax.jdo.Query $Q,...) {
                    ...
                  }
          - pattern-not: |
              $Q.$METHOD("..." + "...",...);
          - metavariable-regex:
              metavariable: $METHOD
              regex: ^(setFilter|setGrouping)$
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          String $SQL = $X + $Y;
                          ...
                      - pattern-inside: |
                          String $SQL = String.format(...);
                          ...
                      - pattern-inside: |
                          $VAL $FUNC(...,String $SQL,...) {
                            ...
                          }
                  - pattern-not-inside: |
                      String $SQL = "..." + "...";
                      ...
                  - pattern: $PM.newQuery(...,$SQL,...)
              - pattern: |
                  $PM.newQuery(...,String.format(...),...);
              - pattern: |
                  $PM.newQuery(...,$X + $Y,...);
          - pattern-either:
              - pattern-inside: |
                  javax.jdo.PersistenceManager $PM = ...;
                  ...
              - pattern-inside: |
                  $TYPE $FUNC(...,javax.jdo.PersistenceManager $PM,...) {
                    ...
                  }
          - pattern-not: |
              $PM.newQuery(...,"..." + "...",...);
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - java
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: jpa-sqli
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    patterns:
      - pattern-either:
          - patterns:
              - pattern-either:
                  - pattern-inside: |
                      String $SQL = $X + $Y;
                      ...
                  - pattern-inside: |
                      String $SQL = String.format(...);
                      ...
                  - pattern-inside: |
                      $TYPE $FUNC(...,String $SQL,...) {
                        ...
                      }
              - pattern-not-inside: |
                  String $SQL = "..." + "...";
                  ...
              - pattern: $EM.$METHOD($SQL,...)
          - pattern: |
              $EM.$METHOD(String.format(...),...);
          - pattern: |
              $EM.$METHOD($X + $Y,...);
      - pattern-either:
          - pattern-inside: |
              EntityManager $EM = ...;
              ...
          - pattern-inside: |
              $TYPE $FUNC(...,EntityManager $EM,...) {
                ...
              }
      - pattern-not: |
          $EM.$METHOD("..." + "...",...);
      - metavariable-regex:
          metavariable: $METHOD
          regex: ^(createQuery|createNativeQuery)$
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - jpa
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: turbine-sqli
    pattern-either:
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          String $SQL = $X + $Y;
                          ...
                      - pattern-inside: |
                          String $SQL = String.format(...);
                          ...
                      - pattern-inside: |
                          $VAL $FUNC(...,String $SQL,...) {
                            ...
                          }
                  - pattern-not-inside: |
                      String $SQL = "..." + "...";
                      ...
                  - pattern: $PEER.executeQuery($SQL,...)
              - pattern: |
                  $PEER.executeQuery(String.format(...),...)
              - pattern: |
                  $PEER.executeQuery($X + $Y,...)
          - pattern-not: |
              $PEER.executeQuery("..." + "...",...)
          - metavariable-regex:
              metavariable: $PEER
              regex: (BasePeer|GroupPeer)
      - patterns:
          - pattern-either:
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          String $SQL = $X + $Y;
                          ...
                      - pattern-inside: |
                          String $SQL = String.format(...);
                          ...
                      - pattern-inside: |
                          $VAL $FUNC(...,String $SQL,...) {
                            ...
                          }
                  - pattern-not-inside: |
                      String $SQL = "..." + "...";
                      ...
                  - pattern: $P.executeQuery($SQL,...)
              - pattern: |
                  $P.executeQuery(String.format(...),...)
              - pattern: |
                  $P.executeQuery($X + $Y,...)
          - pattern-either:
              - pattern-inside: |
                  BasePeer $P = ...;
                  ...
              - pattern-inside: |
                  GroupPeer $P = ...;
                  ...
              - pattern-inside: |
                  $VAL $FUNC(...,GroupPeer $P,...) {
                    ...
                  }
              - pattern-inside: |
                  $VAL $FUNC(...,BasePeer $P,...) {
                    ...
                  }
          - pattern-not: |
              $P.executeQuery("..." + "...",...)
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - turbine
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: vertx-sqli
    message: Detected a formatted string in a SQL statement. This could lead to SQL
      injection if variables in the SQL statement are not properly sanitized.
      Use a prepared statements (java.sql.PreparedStatement) instead. You can
      obtain a PreparedStatement using 'connection.prepareStatement'.
    languages:
      - java
    severity: WARNING
    patterns:
      - pattern-either:
          - patterns:
              - pattern-either:
                  - pattern-inside: |
                      String $SQL = $X + $Y;
                      ...
                  - pattern-inside: |
                      String $SQL = String.format(...);
                      ...
                  - pattern-inside: |
                      $TYPE $FUNC(...,String $SQL,...) {
                        ...
                      }
              - pattern-not-inside: |
                  String $SQL = "..." + "...";
                  ...
              - pattern: $SC.$METHOD($SQL,...)
          - pattern: |
              $SC.$METHOD(String.format(...),...);
          - pattern: |
              $SC.$METHOD($X + $Y,...);
      - pattern-either:
          - pattern-inside: |
              SqlClient $SC = ...;
              ...
          - pattern-inside: |
              SqlConnection $SC = ...;
              ...
          - pattern-inside: |
              $TYPE $FUNC(...,SqlClient $SC,...) {
                ...
              }
          - pattern-inside: |
              $TYPE $FUNC(...,SqlConnection $SC,...) {
                ...
              }
      - pattern-not: |
          $SC.$METHOD("..." + "...",...);
      - metavariable-regex:
          metavariable: $METHOD
          regex: ^(query|preparedQuery|prepare)$
    metadata:
      cwe:
        - "CWE-89: Improper Neutralization of Special Elements used in an SQL
          Command ('SQL Injection')"
      category: security
      technology:
        - vertx
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - audit
      likelihood: LOW
      impact: HIGH
      confidence: LOW
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - SQL Injection
  - id: tainted-env-from-http-request
    message: Detected input from a HTTPServletRequest going into the environment
      variables of an 'exec' command.  Instead, call the command with
      user-supplied arguments by using the overloaded method with one String
      array as the argument. `exec({"command", "arg1", "arg2"})`.
    languages:
      - java
    severity: ERROR
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern: |
                  (HttpServletRequest $REQ)
              - patterns:
                  - pattern-inside: >
                      (javax.servlet.http.Cookie[] $COOKIES) =
                      (HttpServletRequest $REQ).getCookies(...);

                      ...

                      for (javax.servlet.http.Cookie $COOKIE: $COOKIES) {
                        ...
                      }
                  - pattern: |
                      $COOKIE.getValue(...)
    pattern-sinks:
      - patterns:
          - pattern: (java.lang.Runtime $R).exec($CMD, $ENV_ARGS, ...);
          - focus-metavariable: $ENV_ARGS
    metadata:
      category: security
      technology:
        - java
      cwe:
        - "CWE-454: External Initialization of Trusted Variables or Data Stores"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: false
      cwe2021-top25: false
      subcategory:
        - vuln
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Other
  - id: tainted-cmd-from-http-request
    message: Detected input from a HTTPServletRequest going into a 'ProcessBuilder'
      or 'exec' command. This could lead to command injection if variables
      passed into the exec commands are not properly sanitized. Instead, avoid
      using these OS commands with user-supplied input, or, if you must use
      these commands, use a whitelist of specific values.
    languages:
      - java
    severity: ERROR
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern: |
                  (HttpServletRequest $REQ)
              - patterns:
                  - pattern-inside: >
                      (javax.servlet.http.Cookie[] $COOKIES) =
                      (HttpServletRequest $REQ).getCookies(...);

                      ...

                      for (javax.servlet.http.Cookie $COOKIE: $COOKIES) {
                        ...
                      }
                  - pattern: |
                      $COOKIE.getValue(...)
    pattern-sinks:
      - patterns:
          - pattern-either:
              - pattern: |
                  (ProcessBuilder $PB) = ...;
              - patterns:
                  - pattern: |
                      (Process $P) = ...;
                  - pattern-not: |
                      (Process $P) = (java.lang.Runtime $R).exec(...);
              - patterns:
                  - pattern: (java.lang.Runtime $R).exec($CMD, ...);
                  - focus-metavariable: $CMD
              - patterns:
                  - pattern-either:
                      - pattern-inside: |
                          (java.util.List<$TYPE> $ARGLIST) = ...;  
                          ...
                          (ProcessBuilder $PB) = ...;
                          ...
                          $PB.command($ARGLIST);
                      - pattern-inside: |
                          (java.util.List<$TYPE> $ARGLIST) = ...;  
                          ...
                          (ProcessBuilder $PB) = ...;
                      - pattern-inside: |
                          (java.util.List<$TYPE> $ARGLIST) = ...;  
                          ...
                          (Process $P) = ...;
                  - pattern: |
                      $ARGLIST.add(...);
    metadata:
      category: security
      technology:
        - java
      cwe:
        - "CWE-78: Improper Neutralization of Special Elements used in an OS
          Command ('OS Command Injection')"
      owasp:
        - A01:2017 - Injection
        - A03:2021 - Injection
      references:
        - https://owasp.org/Top10/A03_2021-Injection
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: MEDIUM
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Command Injection
  - id: httpservlet-path-traversal
    metadata:
      cwe:
        - "CWE-22: Improper Limitation of a Pathname to a Restricted Directory
          ('Path Traversal')"
      owasp:
        - A05:2017 - Broken Access Control
        - A01:2021 - Broken Access Control
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#PATH_TRAVERSAL_IN
      references:
        - https://www.owasp.org/index.php/Path_Traversal
      category: security
      technology:
        - java
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: HIGH
      impact: MEDIUM
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Path Traversal
    message: Detected a potential path traversal. A malicious actor could control
      the location of this file, to include going backwards in the directory
      with '../'. To address this, ensure that user-controlled variables in file
      paths are sanitized. You may also consider using a utility method such as
      org.apache.commons.io.FilenameUtils.getName(...) to only retrieve the file
      name from the path.
    mode: taint
    pattern-sources:
      - patterns:
          - pattern-either:
              - pattern: |
                  (HttpServletRequest $REQ)
              - patterns:
                  - pattern-inside: >
                      (javax.servlet.http.Cookie[] $COOKIES) =
                      (HttpServletRequest $REQ).getCookies(...);

                      ...

                      for (javax.servlet.http.Cookie $COOKIE: $COOKIES) {
                        ...
                      }
                  - pattern: |
                      $COOKIE.getValue(...)
              - patterns:
                  - pattern-inside: |
                      $TYPE[] $VALS = (HttpServletRequest $REQ).$GETFUNC(...);
                      ...
                  - pattern: |
                      $PARAM = $VALS[$INDEX];
    pattern-sanitizers:
      - pattern: org.apache.commons.io.FilenameUtils.getName(...)
    pattern-sinks:
      - patterns:
          - pattern-either:
              - pattern: |
                  (java.io.File $FILE) = ...
              - pattern: |
                  (java.io.FileOutputStream $FOS) = ...
              - pattern: |
                  new java.io.FileInputStream(...)
    severity: ERROR
    languages:
      - java
  - id: jax-rs-path-traversal
    metadata:
      owasp:
        - A05:2017 - Broken Access Control
        - A01:2021 - Broken Access Control
      cwe:
        - "CWE-22: Improper Limitation of a Pathname to a Restricted Directory
          ('Path Traversal')"
      source-rule-url: https://find-sec-bugs.github.io/bugs.htm#PATH_TRAVERSAL_IN
      references:
        - https://www.owasp.org/index.php/Path_Traversal
      category: security
      technology:
        - jax-rs
      cwe2022-top25: true
      cwe2021-top25: true
      subcategory:
        - vuln
      likelihood: LOW
      impact: LOW
      confidence: MEDIUM
      license: Commons Clause License Condition v1.0[LGPL-2.1-only]
      vulnerability_class:
        - Path Traversal
    message: Detected a potential path traversal. A malicious actor could control
      the location of this file, to include going backwards in the directory
      with '../'. To address this, ensure that user-controlled variables in file
      paths are sanitized. You may also consider using a utility method such as
      org.apache.commons.io.FilenameUtils.getName(...) to only retrieve the file
      name from the path.
    severity: WARNING
    languages:
      - java
    pattern-either:
      - pattern: |
          $RETURNTYPE $FUNC (..., @PathParam(...) $TYPE $VAR, ...) {
            ...
            new File(..., $VAR, ...);
            ...
          }
      - pattern: |-
          $RETURNTYPE $FUNC (..., @javax.ws.rs.PathParam(...) $TYPE $VAR, ...) {
            ...
            new File(..., $VAR, ...);
            ...
          }





